clear;
clc;

load LE;
X=LE;

T=10;
ACC=zeros(T,1);
ARI=zeros(T,1);
NMI=zeros(T,1);

[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);

rand('seed',9);

for t=1:T
    Modes=X(randperm(Pm.Xlth,Pm.k),1:Pm.Xwd);
    % combine EBDM with different clustering algorithms
    
    [ACC(t),ARI(t),NMI(t)] = KM_main(X,Modes); % K-modes algorithm (KM)
    
    %[ACC(t),ARI(t),NMI(t)] = WKM_main(X,Modes); % attribute weighting
    %version of K-modes (WKM)
    
    %[ACC(t),ARI(t),NMI(t)] = EWKM_main(X,Modes); % entropy-based attribute
    %weighting version of K-modes (EWKM)
    
    %[ACC(t),ARI(t),NMI(t)] = WOCIL_main(X,Modes); % attribute weighting
    %version of object-cluster similarity-based iterative learning (WOCIL)
end

% display results
AccMean=mean(ACC)
AccStd=std(ACC);
ARIMean=mean(ARI)
ARIStd=std(ARI);
NMIMean=mean(NMI)
NMIStd=std(NMI);
