
%%%   EWKM algorithm   %%%%%%%

function [ACC,ARI,NMI] = WOCIL_main(x,Modes)

%%
[n,d]=size(x);
true_class=(x(:,d));
true_class = true_class';
d=d-1;
x=x(:,1:d);
k=max(true_class);
m=1;
for i=1:d
    t=max(x(:,i));
    if t>m
        m=t;
    end
end
Pm.Xlth=n;
Pm.Xwd=d;
Pm.k=k;
Pm.O=4; %*%*%*%*%*%*%*%* set this for different data sets
%%% 0 for pure nominal data, d for pure ordinal data %%%

%%
[x,Pm,AttMtx] = EBDMPre(x,Pm);

%%
value_frequency = zeros(m, d); %%%frequency of each attribute value in the whole data set
for i = 1:n
    for j = 1:d
        value_frequency(x(i, j), j) = value_frequency(x(i, j), j) + 1;
    end
end

miu = Modes;  %%% k modes

f_weight = ones(d, k)./d;  %%% feature weights


%%
%%%%% Assign the data in the initial k clusters %%%%%%%%%%
cluster_label = zeros(1, n);
cluster_count = zeros(1, k);
%frequency_in_cluster = zeros(k, d, m);
for i = 1:n
    [DistVec] = EBDMDist_WOCIL(x(i,:),miu,AttMtx,Pm,f_weight);
    [~,j]=min(DistVec);
    cluster_label(i)=j;
    cluster_count(j) = cluster_count(j) + 1;
end
%%
%%%%%%% update the initial k modes %%%%%%%%%%%%%%%%%%%%%%%%%%%
[new_miu, ~] = Update_modes(cluster_label, x, k, m);

%%
%%%%%%%% Iterative steps: adjust the cluster label of each data and update the modes of corresponding clusters
%%%%%%%% untill no data need to change class. %%%%%%%%%%%%%%%%%%%%%%%%%%

moves = 1;
epoch = 0;
while (moves ~= 0)&&(epoch < 50) %%% some class label has been changed in the last step%%%
    moves = 0;    
    %%
    for i = 1:n  %%%update the cluster label of all data
        [DistVec] = EBDMDist_WOCIL(x(i,:),new_miu,AttMtx,Pm,f_weight);
        [~,new_label]=min(DistVec);
        if cluster_label(i) ~= new_label  %%% need adjust
            moves = moves + 1;
            old_cluster = cluster_label(i);
            cluster_label(i) = new_label;     %%%%updata cluster label
            cluster_count(new_label) = cluster_count(new_label) + 1;
            cluster_count(old_cluster) = cluster_count(old_cluster) - 1;   %%%%update cluster counter
        end
    end
    [new_miu, ~] = Update_modes(cluster_label, x, k, m);    
    epoch = epoch + 1;
    %%
    %%%%% Update feature weights
    F = zeros(k, d);
    M = zeros(k,d);
    for j = 1:d
        for c = 1:k
           %% 
            % compute F factor 
            p1_n=zeros(1,m);
            p2_n=zeros(1,m);
            c_cluster_lct= cluster_label==c;
            c_j_x=x(c_cluster_lct,j);
            c_j_n=length(c_j_x);
            for i=1:m
                p1_n(i)=length(find(c_j_x==i));
                p2_n(i)=length(find(x(:,j)==i))-p1_n(i);
            end
            p1=p1_n/c_j_n;
            p2=p2_n/(n-c_j_n);
            F(c,j)=sqrt(sum((p1-p2).^2))/sqrt(2);
           %%
            % compute M factor
            M(c,j)=sum(p1_n.^2/c_j_n)/c_j_n;
        end
    end
    weight_value = F.*M;
    weight_value = weight_value';
    weight_regular = sum(weight_value);
    for c = 1:k
        f_weight(:, c) = weight_value(:, c)./weight_regular(c);
    end
end

%%
%%%% Clustering accuracy
[ACC,Confu_Matrix,~] = calAccuracy(cluster_label',true_class');

%%
%%% ARI index
ARI = calRI(cluster_label,true_class,'adjusted');

%%
%%% NMI index
[NMI,~,~,~,~] = calNMI(Confu_Matrix, n);

end

            