
function [NMI_value,Enlarge_Matrix, I_index,H_obtain,H_true]= calNMI(Confu_Matrix, N)


[true_k, obtain_k] = size(Confu_Matrix);
Enlarge_Matrix = zeros(true_k+1, obtain_k+1);

Enlarge_Matrix(1:true_k, 1:obtain_k) = Confu_Matrix;
Enlarge_Matrix(true_k+1, 1:obtain_k) = sum(Confu_Matrix);
Enlarge_Matrix(1:true_k, obtain_k+1) = (sum(Confu_Matrix'))';

I_index = 0;
for i = 1:obtain_k
    for j = 1:true_k
        if Confu_Matrix(j, i) == 0
            I_index = I_index + 0;
        else
            I_index = I_index + Confu_Matrix(j, i)*log2((N*Confu_Matrix(j, i))/(Enlarge_Matrix(true_k+1, i)*Enlarge_Matrix(j, obtain_k+1)));
        end
    end
end

H_obtain = 0;
for i = 1:obtain_k
    if Enlarge_Matrix(true_k+1, i) == 0
        H_obtain = H_obtain + 0;
    else
        H_obtain = H_obtain + Enlarge_Matrix(true_k+1, i)*log2(Enlarge_Matrix(true_k+1, i)/N);
    end
end

H_true = 0;
for i = 1:true_k
    H_true = H_true + Enlarge_Matrix(i, obtain_k+1)*log2(Enlarge_Matrix(i, obtain_k+1)/N);
end

if H_obtain == 0 || H_true == 0
    NMI_value = 0;
else
    NMI_value = I_index/sqrt(H_obtain*H_true);
end



